Import data from Swagger

Prev Next

Available in Classic and VPC

Create a resource by importing a Swagger file.

Request

The following describes the request format for the endpoint. The request format is as follows:

Method URI
POST /api/v1/products/{product-id}/apis/import

Request headers

For information about the headers common to all API Gateway APIs, see API Gateway request headers.

Request path parameters

You can use the following path parameters with your request:

Field Type Required Description
product-id String Required Product ID associated with the API

Request syntax

The request syntax is as follows.

{
  "apiName" : "apiName",
  "apiDescription" : "apiDescription",
  "importValidateType" : "importValidateType",
  "swagger" : "swagger"
}

Request body

The following describes the request body.

Field Type Required Description
apiName String Required Description for the API deployment
  • 1 - 20 characters
apiDescription String Optional Stage ID created on the API to deploy
  • 0 - 300 characters
importValidateType String Required Determine whether to abort the import or ignore it and import if an error or warning occurs when importing a Swagger file
  • FAIL_ON_WARN | IGNORE_WARN
    • FAIL_ON_WARN: Fail on warning
    • IGNORE_WARN: Ignore warning
swagger String Required Full value of Swagger to import

Request example

The following is a sample request.

curl -X POST 'https://apigateway.apigw.ntruss.com/api/v1/products/{product-id}/apis/import' \
--header 'Content-Type: application/json' \
--header 'x-ncp-apigw-timestamp: {Timestamp}' \
--header 'x-ncp-iam-access-key: {Access Key}' \
--header 'x-ncp-apigw-signature-v2: {API Gateway Signature}' \
--data '{
  "apiName": "api-***",
  "apiDescription": "api-*** Description",
  "importValidateType": "FAIL_ON_WARN",
  "swagger": "{\n  \"openapi\" : \"3.0.1\",\n ~~~ "x-original-swagger-version\" : \"2.0\"\n}"
}'

Response

The following describes the response format.

Response syntax

The response syntax is as follows.

{
    "success": true,
    "warnMessages": [warnMessages],
    "errorMessages": [errorMessages],
    "api": {
        "productId": "productId",
        "apiId": "apiId",
        "apiName": "apiName",
        "apiDescription": "apiDescription",
        "tenantId": "tenantId",
        "modifier": "modifier",
        "modTime": "2024-05-13T04:13:56Z",
        "isDeleted": false,
        "domainCode": "domainCode"
    }
}

Response status codes

For information about the HTTP status codes common to all API Gateway APIs, see API Gateway response status codes.

Response example

The following is a sample response.

{
    "success": true,
    "warnMessages": [],
    "errorMessages": [],
    "api": {
        "productId": "*****n0bk",
        "apiId": "*****ie0xz",
        "apiName": "api-***",
        "apiDescription": "api-*** Description",
        "tenantId": "*****02f55ae4436913a6e2c65bab47c",
        "modifier": "d12c9fd0-****-****-****-246e96591a38",
        "modTime": "2024-05-13T04:13:56Z",
        "isDeleted": false,
        "domainCode": "PUB"
    }
}